/* qlite.vapi generated by valac 0.36.0, do not modify. */

namespace Qlite {
	[CCode (cheader_filename = "qlite.h")]
	public abstract class Column<T> {
		public class BoolInt : Qlite.Column<bool> {
			public BoolInt (string name);
			public override bool @get (Qlite.Row row);
		}
		public class BoolText : Qlite.Column<bool> {
			public BoolText (string name);
			public override bool @get (Qlite.Row row);
		}
		public class Integer : Qlite.Column<int> {
			public Integer (string name);
			public override int @get (Qlite.Row row);
			public override bool is_null (Qlite.Row row);
		}
		public class Long : Qlite.Column<long> {
			public Long (string name);
			public override long @get (Qlite.Row row);
			public override bool is_null (Qlite.Row row);
		}
		public class Real : Qlite.Column<double> {
			public Real (string name);
			public override double @get (Qlite.Row row);
			public override bool is_null (Qlite.Row row);
		}
		public class Text : Qlite.Column<string?> {
			public Text (string name);
			public override string? @get (Qlite.Row row);
			public override bool is_null (Qlite.Row row);
		}
		public Column (string name, int type);
		public abstract T @get (Qlite.Row row);
		public virtual bool is_null (Qlite.Row row);
		public string to_string ();
		public bool auto_increment { get; set; }
		public string @default { get; set; }
		public long max_version { get; set; }
		public long min_version { get; set; }
		public string name { get; private set; }
		public bool not_null { get; set; }
		public bool primary_key { get; set; }
		public int sqlite_type { get; private set; }
		public bool unique { get; set; }
	}
	[CCode (cheader_filename = "qlite.h")]
	public class Database {
		public bool debug;
		public Database (string file_name, long expected_version);
		public Qlite.DeleteBuilder @delete () throws Qlite.DatabaseError;
		public void ensure_init () throws Qlite.DatabaseError;
		public void init (Qlite.Table[] tables) throws Qlite.DatabaseError;
		public Qlite.InsertBuilder insert () throws Qlite.DatabaseError;
		public bool is_known_column (string table, string field) throws Qlite.DatabaseError;
		public virtual void migrate (long old_version) throws Qlite.DatabaseError;
		public Qlite.RowIterator query_sql (string sql, string[]? args = null) throws Qlite.DatabaseError;
		public Qlite.QueryBuilder select (Qlite.Column[]? columns = null) throws Qlite.DatabaseError;
		public Qlite.UpdateBuilder update (Qlite.Table table) throws Qlite.DatabaseError;
		public Qlite.UpdateBuilder update_named (string table) throws Qlite.DatabaseError;
	}
	[CCode (cheader_filename = "qlite.h")]
	public class DeleteBuilder : Qlite.StatementBuilder {
		public Qlite.DeleteBuilder from (Qlite.Table table) throws Qlite.DatabaseError;
		public Qlite.DeleteBuilder from_name (string table);
		public void perform () throws Qlite.DatabaseError;
		public Qlite.DeleteBuilder where (string selection, string[]? selection_args = null) throws Qlite.DatabaseError;
		public Qlite.DeleteBuilder with<T> (Qlite.Column<T> column, string comp, T value);
	}
	[CCode (cheader_filename = "qlite.h")]
	public class InsertBuilder : Qlite.StatementBuilder {
		public Qlite.InsertBuilder into (Qlite.Table table);
		public Qlite.InsertBuilder into_name (string table);
		public Qlite.InsertBuilder or (string or);
		public int64 perform () throws Qlite.DatabaseError;
		public Qlite.InsertBuilder replace ();
		public Qlite.InsertBuilder value<T> (Qlite.Column<T> column, T value);
		public Qlite.InsertBuilder value_null<T> (Qlite.Column<T> column) throws Qlite.DatabaseError;
	}
	[CCode (cheader_filename = "qlite.h")]
	public class QueryBuilder : Qlite.StatementBuilder {
		public int64 count () throws Qlite.DatabaseError;
		public Qlite.QueryBuilder from (Qlite.Table table) throws Qlite.DatabaseError;
		public Qlite.QueryBuilder from_name (string table);
		public T @get<T> (Qlite.Column<T> field) throws Qlite.DatabaseError;
		public Qlite.RowIterator iterator () throws Qlite.DatabaseError;
		public Qlite.QueryBuilder limit (int limit);
		public Qlite.QueryBuilder order_by (Qlite.Column column, string dir = "ASC");
		public Qlite.QueryBuilder order_by_name (string name, string dir);
		public Qlite.RowOption row () throws Qlite.DatabaseError;
		public Qlite.QueryBuilder select (Qlite.Column[]? columns = null);
		public Qlite.QueryBuilder select_string (string column_selector);
		public Qlite.QueryBuilder where (string selection, string[]? selection_args = null) throws Qlite.DatabaseError;
		public Qlite.QueryBuilder with<T> (Qlite.Column<T> column, string comp, T value);
		public Qlite.QueryBuilder with_null<T> (Qlite.Column<T> column);
		public Qlite.QueryBuilder without_null<T> (Qlite.Column<T> column);
	}
	[CCode (cheader_filename = "qlite.h")]
	public class Row {
		public T @get<T> (Qlite.Column<T> field);
		public long get_integer (string field);
		public double get_real (string field);
		public string? get_text (string field);
		public bool has_integer (string field);
		public bool has_real (string field);
	}
	[CCode (cheader_filename = "qlite.h")]
	public class RowIterator {
		public RowIterator (Qlite.Database db, string sql, string[]? args = null) throws Qlite.DatabaseError;
		public RowIterator.from_query_builder (Qlite.Database db, Qlite.QueryBuilder query) throws Qlite.DatabaseError;
		public Qlite.Row? next_value () throws Qlite.DatabaseError;
	}
	[CCode (cheader_filename = "qlite.h")]
	public class RowOption {
		public RowOption (Qlite.Row? row);
		public T @get<T> (Qlite.Column<T> field, T def = null);
		public bool is_present ();
		public Qlite.Row? inner { get; private set; }
	}
	[CCode (cheader_filename = "qlite.h")]
	public abstract class StatementBuilder {
		protected Qlite.Database db;
	}
	[CCode (cheader_filename = "qlite.h")]
	public class Table {
		protected Qlite.Column[] columns;
		protected Qlite.Database db;
		public Table (Qlite.Database db, string name);
		public void add_columns_for_version (long old_version, long new_version) throws Qlite.DatabaseError;
		public void create_table_at_version (long version) throws Qlite.DatabaseError;
		public Qlite.DeleteBuilder @delete () throws Qlite.DatabaseError;
		public void delete_columns_for_version (long old_version, long new_version) throws Qlite.DatabaseError;
		public void init (Qlite.Column[] columns, string? constraints = null);
		public Qlite.InsertBuilder insert () throws Qlite.DatabaseError;
		public bool is_known_column (string column) throws Qlite.DatabaseError;
		public Qlite.RowOption row_with<T> (Qlite.Column<T> column, T value) throws Qlite.DatabaseError;
		public Qlite.QueryBuilder select (Qlite.Column[]? columns = null) throws Qlite.DatabaseError;
		public void unique (Qlite.Column[] columns, string? on_conflict = null);
		public Qlite.UpdateBuilder update () throws Qlite.DatabaseError;
		public string name { get; private set; }
	}
	[CCode (cheader_filename = "qlite.h")]
	public class UpdateBuilder : Qlite.StatementBuilder {
		public Qlite.UpdateBuilder or (string or);
		public void perform () throws Qlite.DatabaseError;
		public Qlite.UpdateBuilder @set<T> (Qlite.Column<T> column, T value);
		public Qlite.UpdateBuilder set_null<T> (Qlite.Column<T> column) throws Qlite.DatabaseError;
		public Qlite.UpdateBuilder where (string selection, string[]? selection_args = null) throws Qlite.DatabaseError;
		public Qlite.UpdateBuilder with<T> (Qlite.Column<T> column, string comp, T value);
		public Qlite.UpdateBuilder with_null<T> (Qlite.Column<T> column);
		public Qlite.UpdateBuilder without_null<T> (Qlite.Column<T> column);
	}
	[CCode (cheader_filename = "qlite.h")]
	public errordomain DatabaseError {
		ILLEGAL_QUERY,
		NOT_SUPPORTED,
		OPEN_ERROR,
		PREPARE_ERROR,
		EXEC_ERROR,
		NON_UNIQUE,
		ILLEGAL_REFERENCE,
		NOT_INITIALIZED
	}
}
